<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="本次变动点数，正加负减" prop="points">
        <el-input v-model="formData.points" placeholder="请输入本次变动点数，正加负减" />
      </el-form-item>
      <el-form-item label="变动后余额快照（冗余）" prop="balance">
        <el-input v-model="formData.balance" placeholder="请输入变动后余额快照（冗余）" />
      </el-form-item>
      <el-form-item label="变动类型，如 TRANSFER_IN, WITHDRAW，REFUND_COMMISSION ，RECHARGE_COMMISSION" prop="type">
        <el-select v-model="formData.type" placeholder="请选择变动类型，如 TRANSFER_IN, WITHDRAW，REFUND_COMMISSION ，RECHARGE_COMMISSION">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="变动描述" prop="description">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
      <el-form-item label="订单 Id/业务单号" prop="orderId">
        <el-input v-model="formData.orderId" placeholder="请输入订单 Id/业务单号" />
      </el-form-item>
      <el-form-item label="业务流水号（转账、订单等唯一标识）" prop="bizNo">
        <el-input v-model="formData.bizNo" placeholder="请输入业务流水号（转账、订单等唯一标识）" />
      </el-form-item>
      <el-form-item label="操作人 Id" prop="operatorId">
        <el-input v-model="formData.operatorId" placeholder="请输入操作人 Id" />
      </el-form-item>
      <el-form-item label="创建时间" prop="createdAt">
        <el-date-picker
          v-model="formData.createdAt"
          type="date"
          value-format="x"
          placeholder="选择创建时间"
        />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { TenantBalanceApi, TenantBalanceTransaction } from '@/api/keyboard/tenantbalance'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  points: undefined,
  balance: undefined,
  type: undefined,
  description: undefined,
  orderId: undefined,
  bizNo: undefined,
  operatorId: undefined,
  createdAt: undefined,
  remark: undefined
})
const formRules = reactive({
  points: [{ required: true, message: '本次变动点数，正加负减不能为空', trigger: 'blur' }],
  createdAt: [{ required: true, message: '创建时间不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number, tenantId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.tenantId = tenantId  as any
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TenantBalanceApi.getTenantBalanceTransaction(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TenantBalanceTransaction
    if (formType.value === 'create') {
      await TenantBalanceApi.createTenantBalanceTransaction(data)
      message.success(t('common.createSuccess'))
    } else {
      await TenantBalanceApi.updateTenantBalanceTransaction(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    points: undefined,
    balance: undefined,
    type: undefined,
    description: undefined,
    orderId: undefined,
    bizNo: undefined,
    operatorId: undefined,
    createdAt: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>